;
;	>>> Silly Venture Guru <<< - by JAC!
;
;	Done for SillyPack 2k13. 
;	Pack main segment with superpacker (exomizer: depack=$1f00, buffer=$bb00, effect: sta $d201) and save it as SillyVentureGuru.xex
;	@com.wudsn.ide.asm.outputfile=SillyVentureGuru-Unpacked.xex

	icl "Generator/no_name.h"

	.macro m_info	;Works with ranges like ".PROC", ".LOCAL"
	.print ":1: " , :1, " - ", :1 + .len :1 -1, " (", .len :1,")"
	.endm

basicf	= $3f8

	opt f-

;===============================================================

	org $80			;Fixed, was $00 before

fcnt	.ds 2
fadr	.ds 2
fhlp	.ds 2
cloc	.ds 1
regA	.ds 1
regX	.ds 1
regY	.ds 1
byt2	.ds 1

p1 	 .ds 2
text_ptr .ds 2
text_sm	= $bf00

;===============================================================
	org $2000		;Loader

	.proc loader_init
	mva #$ff portb		;BASIC off
	mva #$01 basicf
	rts
	.endp

	ini loader_init

;===============================================================

	org $2000		;Demo

	opt f+			;Improve packer performance

	.align $400
	.local text_chr
	ins 'SillyVentureGuru.chr'
	.endl

	.align $100
	.proc player
	icl "TM2-Player.asm"
	.endp

;	opt f+			;Single chunk to optimize for Supercuncher

	icl "SillyVentureGuru-Meditation.asm"

	.proc demo

cnt	= $14

;===============================================================

	.proc init

	lda #$70			;Set module
	ldx #>msx
	ldy #<msx
	jsr player.init

	ldx #0				;Set song and line
	txa
	jsr player.init
	
	.proc init_text
	lda #<text
	sta text_ptr
	sta p1
	lda #>text
	sta text_ptr+1
	sta p1+1

	ldy #0
char_loop
	lda (p1),y
	bmi done
	ldx #.len text_encoding-1
encoding_loop
	cmp text_encoding,x
	beq found
	dex
	bpl encoding_loop
	.byte 2
found	txa
	sta (p1),y
	inw p1
	jmp char_loop

done	rts
	
	.local text_encoding
	.byte '@abcdefghijklmnopqrstuvwxyz[*]**'
	.byte ' !"#$**''()*+,-./0123456789*****?'
	.endl
	
	.endp

	.endp			;End of init

;===============================================================
	.proc vbi
	mva #>text_chr $d409
	mva #$3f dmactl
	mva #14 $d017

	lda cnt
	and #3
	eor #3
	sta $d404
	cmp #3
	bne not_next_char
	inw text_ptr
not_next_char
	cpw text_ptr #[text+.len text]
	bne not_last_char
	mwa #text text_ptr
not_last_char

	ldy #47
copy_chars
	.rept 2
	lda (text_ptr),y		;unrolled for speed
	sta text_sm,y
	ora #$40
	sta text_sm+48,y
	dey
	.endr
	bpl copy_chars

	inc cnt
	jsr player.play
	rts
	.endp			;End of vbi

	.local text
:48	.byte ' '
	.byte '  '
	.byte 'this invitation is dedicated to the one and only silly venture guru - to grey! '
	.byte 'the man who made the world''s biggest atari event possible with sheer super human power and passion. '
	.byte 'i was really hoping he finds the motivation and help to launch silly venture 2k14. '
 	.byte 'and hell yeah, today he officially annouced it. come to gdansk on 5-7 december 2014! '
	.byte 'i''m sure i''ll get a truck load full of stuff to pack into sillypack 2k14 - and i''ll be happy to work my ass off (again)!    '
	.byte 'code by jac! graphics by ukko. font by sdw. music by bewu. '
	.byte 'greetings to grey, agenda, checkpoint, desire, dma, lamers, mec, larestistance, mystic bytes, noice, squoquo and all demo lovers i''ve met so far. stay atari!'
	.endl
:48	.byte ' '
	.byte $ff

	.endp			;End of demo

;===============================================================

	.proc main

	jsr guru_meditation.show
	sei			;stop interrups
	lda #0
	sta $d400
	sta nmien
	mva #>pmg pmbase	;missiles and players data address
	mva #$03 pmcntl		;enable players and missiles

////////////////////
// RASTER PROGRAM //
////////////////////

	jsr demo.init
wait_sync
	lda $d40b
	bne wait_sync

LOOP	lda #$ff
	sta sizep0
	sta sizep1
	sta sizep2
	sta sizep3
	sta sizem
	sta grafm
	mva #$20 hposm0
	mva #$28 hposm1
	mva #$d0 hposm2
	mva #$d8 hposm3

	mva #$02 pmcntl
	lda #$14
	sta gtictl

	lda vcount		;synchronization for the first screen line
	cmp #$02
	bne LOOP

	mva #%00111110 dmactl	;set new screen width
	mva #<ant dlptr
	mva #>ant dlptr+1

	icl "Generator/output.png.rp.ini"

;--- wait 18 cycles
	jsr _rts
	inc byt3

;--- set global offset (23 cycles)
	jsr _rts
	cmp byt3\ pha:pla

;--- empty line
	jsr wait54cycle
	inc byt2

  	icl "Generator/output.png.rp"

raster_program_end


	lda #$94
	sta $d40a
	sta $d01a
	sta $d019
	sta $d018

//--------------------
//	EXIT
//--------------------

	lda trig0		; FIRE #0
	and trig1		; FIRE #1
	and consol		; START
	beq stop

	lda skctl		; ANY KEY
	and #$04
	bne skp

stop	mva #$00 pmcntl		;PMG disabled
	tax
	sta:rne hposp0,x+
	sta 559
	sta $d400

	jmp $e474
skp

//--------------------
	jsr demo.vbi
	jmp LOOP

;---

wait54cycle
	:2 inc byt2
wait44cycle
	inc byt3
	nop
wait36cycle
	inc byt3
	jsr _rts
wait18cycle
	inc byt3
_rts	rts

byt3	= $ffff


;---

.MACRO	ANTIC_PROGRAM
	:+8 dta $4e,a(:1+$0000+#*40)
	:+8 dta $4e,a(:1+$0140+#*40)
	:+8 dta $4e,a(:1+$0280+#*40)
	:+8 dta $4e,a(:1+$03C0+#*40)
	:+8 dta $4e,a(:1+$0500+#*40)
	:+8 dta $4e,a(:1+$0640+#*40)
	:+8 dta $4e,a(:1+$0780+#*40)
	:+8 dta $4e,a(:1+$08C0+#*40)
	:+8 dta $4e,a(:1+$0A00+#*40)
	:+8 dta $4e,a(:1+$0B40+#*40)
	:+8 dta $4e,a(:1+$0C80+#*40)
	:+8 dta $4e,a(:1+$0DC0+#*40)
	:+8 dta $4e,a(:1+$0F00+#*40)
	:+8 dta $4e,a(:1+$1040+#*40)
	:+8 dta $4e,a(:1+$1180+#*40)
	:+8 dta $4e,a(:1+$12C0+#*40)
	:+8 dta $4e,a(:1+$1400+#*40)
	:+8 dta $4e,a(:1+$1540+#*40)
	:+8 dta $4e,a(:1+$1680+#*40)
	:+8 dta $4e,a(:1+$17C0+#*40)
	:+8 dta $4e,a(:1+$1900+#*40)
	:+8 dta $4e,a(:1+$1A40+#*40)
	:+8 dta $4e,a(:1+$1B80+#*40)
	:+8 dta $4e,a(:1+$1CC0+#*40)
	:+8 dta $4e,a(:1+$1E00+#*40)
.ENDM

	.endp				;End of main
;===============================================================

	org $5c00		;Player missble graphics (players only)
	.local pmg
	icl "Generator/output.png.pmg"
	.endl
	m_info pmg

	org $6010		;Rasterprogram Mode: GED- (bitmap mode)

	.local scr
	ins "Generator/output.png.mic"	;$1e00 bytes
	.endl
	m_info scr

:80	.byte 0			;Empty lines

	org $8000		;Sound module
	.local msx
	ins 'SillyVentureGuru.tm2',+6	;Heavy Traffic
	.endl
	m_info msx

	org $b800		;Display list
	.local ant
	main.ANTIC_PROGRAM scr,ant
	.byte $70
	.byte $52,a(text_sm),$12
	dta $41,a(ant)
	.endl
	
	m_info ant


;===============================================================

	run main

